#ifdef _WIN32
	#include <windows.h>
	#include <process.h>
#endif
#include "aflCfgmsg.h"
#include "aflPeercastSkin.h"

/*
#ifdef _MSC_VER
	#ifdef _DEBUG	//[NeXg
		#include <crtdbg.h>
		#define malloc(a) _malloc_dbg(a,_NORMAL_BLOCK,__FILE__,__LINE__)
		inline void*  operator new(size_t size, LPCSTR strFileName, INT iLine)
			{return _malloc_dbg(size, _NORMAL_BLOCK, strFileName, iLine);}
		inline void operator delete(void *pVoid, LPCSTR strFileName, INT iLine)
			{_free_dbg(pVoid, _NORMAL_BLOCK);}
		#define new new(__FILE__, __LINE__)
		#define CHECK_MEMORY_LEAK _
		CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF|_CRTDBG_ALLOC_MEM_DF);
	#else
		#define CHECK_MEMORY_LEAK
	#endif //_DEBUG
#else
		#define CHECK_MEMORY_LEAK
#endif 
*/


AflPeercastSkin::AflPeercastSkin()
{
	//-------------------------------------------
	m_skinHead =
		"<HTML>\n"
		"<HEAD>\n"
		"<TITLE>[HEAD_TITLE]</TITLE>\n"
		"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">\n"
		"[HEAD_REFRESH]"

		"<style><!--\n"
		"TD.HEAD_ACTIVE {text-align: center;font-weight: bold;}\n"
		"TD.HEAD_IDEL {text-align: center;}\n"
		"//--></style>\n"

		"</HEAD>"
		"<BODY>"
		"<div align='center'><font size='+3'>PeerCast</font> v0.119D</div>\n"

		"<TABLE width='100%%'>\n"
		"<TR bgcolor='#CCCCCC'>"
			"<TD class='[HEAD_01]'><A href='/admin?page=index'>Index</A>"
			"<TD class='[HEAD_02]'><A href='/admin?page=chans'>All channels</A>"
			"<TD class='[HEAD_03]'><A href='/admin?page=mychans'>Relayed channels</A>"
			"<TD class='[HEAD_08]'><A href='/admin?page=broadcast'>Broadcast</A>"
			"<TD class='[HEAD_04]'><A href='/admin?page=connections'>Connections</A>"
			"<TD class='[HEAD_05]'><A href='/admin?page=settings'>Settings</A>"
			"<TD class='[HEAD_07]'><A href='/admin?page=viewlog'>View Log</A>"
			"<TD class='[HEAD_06]'><A href='/admin?page=logout'>Logout</A>\n"
		"</TABLE>\n<BR>\n";

	//-------------------------------------------
	m_skinFoot =
		"<BR><table width='100%%'><tr bgcolor='#CCCCCC'>"
		"<td><div align='center'>&copy; "
		"<a target=\"_blank\" href='/admin?cmd=redirect&url=www.peercast.org'>peercast.org</a> 2003</div></td></tr></table></body></html>\n";

	//-------------------------------------------
	m_skinInfo =
		"<style><!--\n"
		"TR.INFO_A {background-color: #eeeeee;}\n"
		"TR.INFO_B {background-color: #dddddd;}\n"
		"//--></style>\n"
		
		"<TABLE border=\"0\" align=\"center\">\n"
		"<TR align=\"center\">"

		"<TD valign='top'><TABLE width=\"100%%\" border='0'>\n"
		"<TR bgcolor=\"#cccccc\" align=\"center\">"
			"<TD colspan='2'><b>Information</b>"
			"<TR class='INFO_A'><TD>Server IP<TD>[SERVER_IP]\n"
			"<TR class='INFO_B'><TD>Uptime<TD>[UPDATE]\n"
			"<TR class='INFO_A'><TD>Channels found<TD>[CHANNEL_FOUND]\n"
			"<TR class='INFO_B'><TD>Total relays<TD>[TOTAL_RELAYS]\n"
			"<TR class='INFO_A'><TD>Total listeners<TD>[TOTAL_LISTENERS]\n"
			"<TR class='INFO_B'><TD>Total streams<TD>[TOTAL_STREAMS]\n"
			"<TR class='INFO_A'><TD>Total connected<TD>[TOTAL_CONNECTED]\n"
			"<TR class='INFO_B'><TD>Num outgoing<TD>[NUM_OUTGOING]\n"
			"<TR class='INFO_A'><TD>Num incoming<TD>[NUM_INCOMEING]"
			"<TR class='INFO_B'><TD>Host cache (Servents)<TD>[HOST_CACHE] - <a href=\"/admin?cmd=clear&hostcache=1\">Clear</a>\n"
			"<TR class='INFO_A'><TD>XML stats<TD><a href=\"/admin?cmd=viewxml\">View</a>\n"
			"<TR class='INFO_B'><TD>Network stats<TD><a href=\"/admin?page=viewnet\">View</a>\n"
		"</TABLE>\n"
		
		"<TD valign='top'><TABLE  width=\"100%%\" border=\"0\" align=\"center\">"
		"<TR bgcolor=\"#cccccc\" align=\"center\">"
			"<TD colspan=\"4\"><b>Bandwidth</b>\n"
			"<TR class='INFO_A'><TD> <TD><b>In</b>   <TD><b>Out</b><TD><b>Total</b>\n"
			"<TR class='INFO_B'><TD>Total (Kbit/s)   <TD>[TOTAL_IN]    <TD>[TOTAL_OUT]    <TD>[TOTAL_ALL]\n"
			"<TR class='INFO_A'><TD>Internet (Kbit/s)<TD>[INTERNET_IN] <TD>[INTERNET_OUT] <TD>[INTERNET_ALL]\n"
			"<TR class='INFO_B'><TD>Network (Kbit/s) <TD>[NETWORK_IN]  <TD>[NETWORK_OUT]  <TD>[NETWORK_ALL]\n"
			"<TR class='INFO_A'><TD>Channels (Kbit/s)<TD>[CHANNELS_IN] <TD>[CHANNELS_OUT] <TD>[CHANNELS_ALL]\n"
			"<TR class='INFO_B'><TD>Packets/sec      <TD>[PAKETS_IN]   <TD>[PAKETS_OUT]   <TD>[PAKETS_ALL]\n"
		"</TABLE>\n"

		"</TABLE>\n";

	//-------------------------------------------
	m_skinSearch =
		"<table border=\"0\" align=\"center\">\n"
		"<form method=\"get\" action=\"/admin\">"
		"<input name=\"page\" type=\"hidden\" value=\"chans\">"
		"<TR><TD><TD>Name<TD>Genre<TD>Bitrate<TD>ID"
		"<TR><TD><input name=\"find\" type=\"submit\" value=\"  Search  \">"
		"<TD><input name='name' type=\"text\" value='[SEARCH_NAME]'>"
		"<TD><input name='genre' type=\"text\" value='[SEARCH_GENRE]'>"
		"<TD><input name='genre' type=\"text\" value='[SEARCH_BITRATE]'>"
		"<TD><input name='genre' type=\"text\" value='[SEARCH_ID]'>"
		"</FORM></TABLE>\n\n";
	//-------------------------------------------
	m_skinChannelHead =
		"<style><!--\n"
		"TR.CHANNEL_A {background-color: #eeeeee;}\n"
		"TR.CHANNEL_B {background-color: #dddddd;}\n"
		"//--></style>\n"
		
		"<table border=\"0\" width=\"95%%\" align=\"center\">"
		"<tr bgcolor=\"#cccccc\" align=\"center\">"
		"<TD><b><a href=\"/admin?page=chans&sort=name&dir=[CH_UP]\">Channel</a></b>"
		"<TD><b><a href=\"/admin?page=chans&sort=genre&dir=[CH_UP]\">Genre</a></b>"
		"<TD width='1%%'><b><a href=\"/admin?page=chans&sort=bitrate&dir=[CH_UP]\">Bitrate (kb/s)</a></b>"
		"<TD width='1%%'><b><a href=\"/admin?page=chans&sort=type&dir=[CH_UP]\">Type</a></b>"
		"<TD width='1%%'><b><a href=\"/admin?page=chans&sort=hosts&dir=[CH_UP]\">Hits</a></b>";
	//-------------------------------------------
	m_skinChannel =
		"<TR class='[CHANNEL_ST]'>"
		"<TD><B>[CHANNEL_NAME]</B>"
			"<FONT size='-1'><br>[CHANNEL_DEST]<BR><I>[CHANNEL_TRACK_ARTIST] - [CHANNEL_TRACK_TITLE]</I>"
			"<BR><B><A href='/pls/[CHANNEL_ID].pls'>Play</A> - "
			"<b><a href='/admin?cmd=relay&id=[CHANNEL_ID]'>Relay</a></b> - "
			"<b><a href='/admin?page=chaninfo&id=[CHANNEL_ID]'>Info</a></b> - "
			"<B>[CHANNEL_URL]</B>"
			"</FONT>"
		"<TD>[CHANNEL_GENRE]"
		"<TD>[CHANNEL_BITRATE]"
		"<TD>[CHANNEL_TYPE]"
		"<TD>[CHANNEL_LISTENER]/[CHANNEL_HOST]";
	//-------------------------------------------
	m_skinChannelNot =
		"<TR><TD>No channels found";
	//-------------------------------------------
	m_skinChannelFoot =
		"</TABLE>\n";
	//-------------------------------------------
	m_skinRelayHead =
		"<style><!--\n"
		"TR.CHANNEL_A {background-color: #eeeeee;}\n"
		"TR.CHANNEL_B {background-color: #dddddd;}\n"
		"//--></style>\n"

		"<table border=\"0\" width=\"95%%\" align=\"center\">"
		"<tr bgcolor=\"#cccccc\" align=\"center\">"
		"<TD><b>Channel</b>"
		"<TD width='1%%'><b>Bitrate (kb/s)</b>"
		"<TD width='1%%'><b>Stream</b>"
		"<TD width='1%%'><b>Relays</b>"
		"<TD width='1%%'><b>Listeners</b>"
		"<TD width='1%%'><b>Status</b>"
		"<TD width='1%%'><b>Keep</b>";
	//-------------------------------------------
	m_skinRelay =
		"<TR class='[CHANNEL_ST]'>"
		"<TD><B>[CHANNEL_NAME]</B>"
			"<FONT size='-1'><br>[CHANNEL_DEST]<BR><I>[CHANNEL_TRACK_ARTIST] - [CHANNEL_TRACK_TITLE]</I>"
			"<b><a href='/admin?cmd=bump&id=[CHANNEL_ID]'>Bump</a></b> - "
			"<BR><B><A href='/pls/[CHANNEL_ID].pls'>Play</A> - "
			"<b><a href='/admin?cmd=stop&id=[CHANNEL_ID]'>Stop</a></b> - "
			"<b><a href='/admin?cmd=keep&id=[CHANNEL_ID]'>Keep</a></b> - "
			"<b><a href='/admin?page=chaninfo&id=[CHANNEL_ID]'>Info</a></b> - "
			"<B>[CHANNEL_URL]</B>"
			"</FONT>"
		"<TD>[CHANNEL_BITRATE]"
		"<TD><a href='/stream/[CHANNEL_ID].[CHANNEL_TYPE]'>[CHANNEL_TYPE]</a></TD>"
		"<TD>[CHANNEL_RELAYS]"
		"<TD>[CHANNEL_LISTENERS]"
		"<TD>[CHANNEL_STATUS]"
		"<TD>[CHANNEL_KEEP]\n";
	//-------------------------------------------
	m_skinRelayFoot =
		"</TABLE>\n";
	//-------------------------------------------
	m_skinBroadcastHead =
		"<style><!--\n"
		"TR.BROADCAST_A {background-color: #eeeeee;}\n"
		"TR.BROADCAST_B {background-color: #dddddd;}\n"
		"//--></style>\n"

		"<table border='0' align='center'><form method='get' action='/admin'>"
		"<input name='cmd' type='hidden' value='fetch'></input>"
		"<tr bgcolor='#cccccc' align='center'>"
		"<td colspan='2' ><b>External Source</b></td></tr>"
		"<tr bgcolor='#eeeeee' align='left'><td>URL (Required)</td><td><input name='url' size='40' type='text' value=''></input></td></tr>"
		"<tr bgcolor='#dddddd' align='left'><td>Name</td><td><input name='name' size='40' type='text' value=''></input></td></tr>"
		"<tr bgcolor='#eeeeee' align='left'><td>Description</td><td><input name='desc' size='40' type='text' value=''></input></td></tr>"
		"<tr bgcolor='#dddddd' align='left'><td>Genre</td><td><input name='genre' size='40' type='text' value=''></input></td></tr>"
		"<tr bgcolor='#eeeeee' align='left'><td>Contact</td><td><input name='contact' size='40' type='text' value=''></input></td></tr>"
		"<tr bgcolor='#dddddd' align='left'><td>Bitrate (kb/s)</td><td><input name='bitrate' size='40' type='text' value=''></input></td></tr>"
		"<tr bgcolor='#eeeeee' align='left'><td>Type</td><td><select name='type'>"
		"<option value='UNKNOWN' selected>Unknown</option>"
		"<option value='MP3'>MP3</option><option value='OGG'>OGG</option>"
		"<option value='WMA'>WMA</option><option value='NSV'>NSV</option>"
		"<option value='WMV'>WMV</option><option value='RAW'>RAW</option>"
		"</select></td></tr>"
		"<tr bgcolor='#dddddd' align='left'><td colspan='2' align='center'><input name='stream' type='submit' value='Create Relay'></input></td></tr>"
		"</form></table><br></br>"
		"<table border='0' width='95%%' align='center'>"
		"<tr bgcolor='#cccccc' align='center'><td><b>Channel</b></td><td><b>Source</b></td><td><b>Sync</b></td><td><b>Bitrate (kb/s)</b></td><td><b>Type</b></td></tr>";
	//-------------------------------------------
	m_skinBroadcast =
		"<tr class='[BROADCAST_ST]'>"
		"<td><a href='peercast://pls/[BROADCAST_ID]?ip=[BROADCAST_IP]'>[BROADCAST_TITLE]</a></td>"
		"<td>[BROADCAST_STYPE]-[BROADCAST_PTYPE]:<br>[BROADCAST_ADDRESS]</td>"
		"<td>[BROADCAST_SYNC]</td><td>[BROADCAST_BITRATE]</td><td>[BROADCAST_TYPE]</td></tr>";
	//-------------------------------------------
	m_skinBroadcastFoot =
		"</table>";
}
bool AflPeercastSkin::open(LPCSTR fileName)
{
	CHAR cfgName[1024];
	strncpy(cfgName,fileName,1000);
	cfgName[1000] = 0;

	LPSTR fileBase = strrchr(cfgName,'.');
	if(fileBase)
		*fileBase = 0;
	strcat(cfgName,".skn");

	Config::CPCfgMes cfgMsg;
	if(!cfgMsg.Init(cfgName))
		return false;

	LPSTR skinText;
	skinText = cfgMsg.Search("HTML","HEAD");
	if(skinText)
	{
		m_skinHead = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","FOOT");
	if(skinText)
	{
		m_skinFoot = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","INFO");
	if(skinText)
	{
		m_skinInfo = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","SEARCH");
	if(skinText)
	{
		m_skinSearch = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","CHANNEL");
	if(skinText)
	{
		m_skinChannel = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","CHANNEL_NOT");
	if(skinText)
	{
		m_skinChannelNot = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","CHANNEL_HEAD");
	if(skinText)
	{
		m_skinChannelHead = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","CHANNEL_FOOT");
	if(skinText)
	{
		m_skinChannelFoot = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","RELAY");
	if(skinText)
	{
		m_skinRelay = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","RELAY_HEAD");
	if(skinText)
	{
		m_skinRelayHead = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","RELAY_FOOT");
	if(skinText)
	{
		m_skinRelayFoot = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","BROADCAST_HEAD");
	if(skinText)
	{
		m_skinBroadcastHead = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","BROADCAST");
	if(skinText)
	{
		m_skinBroadcast = skinText;
		delete[] skinText;
	}

	skinText = cfgMsg.Search("HTML","BROADCAST_FOOT");
	if(skinText)
	{
		m_skinBroadcastFoot = skinText;
		delete[] skinText;
	}

	return true;
}

AflPeercastSkin skinMgr;

